`timescale 1ns / 1ps

////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   02:35:09 04/04/2009
// Design Name:   CHIP_SASEBO_GII_LX50_AES_COMP
// Module Name:   C:/Users/ncc-1701-e/Documents/HDL Designs/aist09s/sasebo_sample_test/sasebo_gii_lx50_aes_comp/sasebo_gii_aes_tb01.v
// Project Name:  sasebo_gii_lx50_aes_comp
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: CHIP_SASEBO_GII_LX50_AES_COMP
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////
//
// Control
//   Bit0  Data ready
//   Bit1  Key ready
//   Bit2  Reset
//   Bit4  I ready
//   Bit5  C ready
//   Bit7  Length ready

`define IV800  128'h000102030405060708090a0b0c0d0e0f // Initial Vector
`define PT800  128'h6bc1bee22e409f96e93d7e117393172a // Plain Text 0
`define PT801  128'hae2d8a571e03ac9c9eb76fac45af8e51 // Plain Text 1
`define PT802  128'h30c81c46a35ce411e5fbc1191a0a52ef // Plain Text 2
`define PT803  128'hf69f2445df4f9b17ad2b417be66c3710 // Plain Text 3

`define CT800ECB128 128'h3ad77bb40d7a3660a89ecaf32466ef97    // ECB128 Cipher Text 0
`define CT801ECB128 128'hf5d3d58503b9699de785895a96fdbaaf    // ECB128 Cipher Text 1
`define CT802ECB128 128'h43b1cd7f598ece23881b00e3ed030688    // ECB128 Cipher Text 2
`define CT803ECB128 128'h7b0c785e27e8ad3f8223207104725dd4    // ECB128 Cipher Text 3


module FPGA1_AES_MULTI_TB1;

	// Inputs
	reg lbus_rstn;
	reg lbus_clk;

	reg [7:0] lbus_wd;
	reg lbus_we;
	reg lbus_re;


	// Outputs
	wire lbus_ful;
	wire lbus_aful;
	wire [7:0] lbus_rd;
	wire lbus_emp;
	wire lbus_aemp;
	wire lbus_rdy;
	wire trig_startn;
	wire trig_endn;
	wire trig_exec;
	wire [7:0] led;

  parameter [127:0] P800 = `PT800;
  parameter [127:0] C800ECB128 = `CT800ECB128;

	// Instantiate the Unit Under Test (UUT)
	FPGA1_AES_MULTI uut (
		.lbus_wd(lbus_wd), 
		.lbus_we(lbus_we), 
		.lbus_ful(lbus_ful), 
		.lbus_aful(lbus_aful), 
		.lbus_rd(lbus_rd), 
		.lbus_re(lbus_re), 
		.lbus_emp(lbus_emp), 
		.lbus_aemp(lbus_aemp), 
		.lbus_rdy(lbus_rdy), 
		.lbus_clk(lbus_clk), 
		.lbus_rstn(lbus_rstn), 
		.trig_startn(trig_startn), 
		.trig_endn(trig_endn), 
		.trig_exec(trig_exec), 
		.led(led)
	);

   parameter PERIOD = 100;
   parameter real DUTY_CYCLE = 0.5;
   parameter OFFSET = 100;
   parameter STEP = 100;

	initial begin
	   forever
        begin
          lbus_clk = 1'b0;
          #(PERIOD-(PERIOD*DUTY_CYCLE)) lbus_clk = 1'b1;
          #(PERIOD*DUTY_CYCLE);
        end
	end

	initial begin
		// Initialize Inputs
		lbus_wd = 0;
		lbus_we = 0;
		lbus_re = 1;
//		lbus_clk = 0;
		lbus_rstn = 0;

		// Wait 100 ns for global reset to finish
		#(STEP*10)  lbus_rstn = 1;
        
		// Add stimulus here
      #(STEP*40);
		write_cmd(16'h0002, 16'h0004);    // Conrtol reset
//      #(STEP*20);
//		write_cmd(16'h000c, 16'h0001);    // Encode mode set


// =====================================================================
// 128biy-Key
// =====================================================================
      #(STEP*20);
		write_cmd(16'h000e, 16'h0000);    // 128-key mode set

      #(STEP*20);
		write_cmd(16'h0100, 16'h2b7e);    // Key set
      write_cmd(16'h0102, 16'h1516);
      write_cmd(16'h0104, 16'h28ae);
      write_cmd(16'h0106, 16'hd2a6);
      write_cmd(16'h0108, 16'habf7);
      write_cmd(16'h010a, 16'h1588);
      write_cmd(16'h010c, 16'h09cf);
      write_cmd(16'h010e, 16'h4f3c);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0002);    // Conrtol Key ready

    // ------------------------------------------------------
    // Example 1: Mlen 0
    // ------------------------------------------------------

      // Data write
      #(STEP*10);
		write_cmd(16'h0140, P800[127:112]);    //Data
      write_cmd(16'h0142, P800[111: 96]);
      write_cmd(16'h0144, P800[ 95: 80]);
      write_cmd(16'h0146, P800[ 79: 64]);
      write_cmd(16'h0148, P800[ 63: 48]);
      write_cmd(16'h014a, P800[ 47: 32]);
      write_cmd(16'h014c, P800[ 31: 16]);
      write_cmd(16'h014e, P800[ 15:  0]);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      // Data Read comnnd
      #(STEP*200);
      #(STEP*10); read_cmd(16'h0180);
      #(STEP*10); read_cmd(16'h0182);
      #(STEP*10); read_cmd(16'h0184);
      #(STEP*10); read_cmd(16'h0186);
      #(STEP*10); read_cmd(16'h0188);
      #(STEP*10); read_cmd(16'h018a);
      #(STEP*10); read_cmd(16'h018c);
      #(STEP*10); read_cmd(16'h018e);
      #(STEP*200);

    // ------------------------------------------------------
    // Example 2: Mlen 128
    // ------------------------------------------------------

		write_cmd(16'h000c, 16'h0001);    // Dec mode set

      // Data write
      #(STEP*10);
		write_cmd(16'h0140, C800ECB128[127:112]);    //Data
      write_cmd(16'h0142, C800ECB128[111: 96]);
      write_cmd(16'h0144, C800ECB128[ 95: 80]);
      write_cmd(16'h0146, C800ECB128[ 79: 64]);
      write_cmd(16'h0148, C800ECB128[ 63: 48]);
      write_cmd(16'h014a, C800ECB128[ 47: 32]);
      write_cmd(16'h014c, C800ECB128[ 31: 16]);
      write_cmd(16'h014e, C800ECB128[ 15:  0]);
      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      // Data Read comnnd
      #(STEP*200);
      #(STEP*10); read_cmd(16'h0180);
      #(STEP*10); read_cmd(16'h0182);
      #(STEP*10); read_cmd(16'h0184);
      #(STEP*10); read_cmd(16'h0186);
      #(STEP*10); read_cmd(16'h0188);
      #(STEP*10); read_cmd(16'h018a);
      #(STEP*10); read_cmd(16'h018c);
      #(STEP*10); read_cmd(16'h018e);
      #(STEP*200);


// =====================================================================
// 192bit key
// =====================================================================
      #(STEP*20);
		write_cmd(16'h000e, 16'h0001);    // 192-key mode set

      #(STEP*20);
		write_cmd(16'h0100, 16'h8e73);    // Key set0
      write_cmd(16'h0102, 16'hb0f7);
      write_cmd(16'h0104, 16'hda0e);
      write_cmd(16'h0106, 16'h6452);
      write_cmd(16'h0108, 16'hc810);
      write_cmd(16'h010a, 16'hf32b);
      write_cmd(16'h010c, 16'h8090);
      write_cmd(16'h010e, 16'h79e5);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0002);    // Conrtol Key ready

      #(STEP*20);
		write_cmd(16'h0100, 16'h62f8);    // Key set
      write_cmd(16'h0102, 16'head2);
      write_cmd(16'h0104, 16'h522c);
      write_cmd(16'h0106, 16'h6b7b);
      write_cmd(16'h0108, 16'h0000);
      write_cmd(16'h010a, 16'h0000);
      write_cmd(16'h010c, 16'h0000);
      write_cmd(16'h010e, 16'h0000);    // Key set

      #(STEP*10);
		write_cmd(16'h0002, 16'h0002);    // Conrtol Key ready


// =====================================================================
// 256bit key
// =====================================================================
      #(STEP*20);
		write_cmd(16'h000e, 16'h0002);    // 256-key mode set

      #(STEP*20);
		write_cmd(16'h0100, 16'h603d);    // Key set0
      write_cmd(16'h0102, 16'heb10);
      write_cmd(16'h0104, 16'h15ca);
      write_cmd(16'h0106, 16'h71be);
      write_cmd(16'h0108, 16'h2b73);
      write_cmd(16'h010a, 16'haef0);
      write_cmd(16'h010c, 16'h857d);
      write_cmd(16'h010e, 16'h7781);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0002);    // Conrtol Key ready

      #(STEP*20);
		write_cmd(16'h0100, 16'h1f35);    // Key set
      write_cmd(16'h0102, 16'h2c07);
      write_cmd(16'h0104, 16'h3b61);
      write_cmd(16'h0106, 16'h08d7);
      write_cmd(16'h0108, 16'h2d98);
      write_cmd(16'h010a, 16'h10a3);
      write_cmd(16'h010c, 16'h0914);
      write_cmd(16'h010e, 16'hdff4);    // Key set

      #(STEP*10);
		write_cmd(16'h0002, 16'h0002);    // Conrtol Key ready


      #(STEP*400);
      $stop;
	end


   // Write command
	task  write_cmd;
	input [15:0] addr;
	input [15:0] data;
	begin
	   #STEP       lbus_we = 1; lbus_wd = 8'h01;       // Write command
      #STEP       lbus_we = 0; lbus_wd = 8'h00;
		#(STEP*2)   lbus_we = 1; lbus_wd = addr[15:8];  // Write address high
      #STEP       lbus_we = 0; lbus_wd = 8'h00;
		#(STEP*2)   lbus_we = 1; lbus_wd = addr[7:0];   // Write address low
      #STEP       lbus_we = 0; lbus_wd = 8'h00;
		#(STEP*2)   lbus_we = 1; lbus_wd = data[15:8];  // Write data high
      #STEP       lbus_we = 0; lbus_wd = 8'h00;
		#(STEP*2)   lbus_we = 1; lbus_wd = data[7:0];   // Write data low
      #STEP       lbus_we = 0; lbus_wd = 8'h00;
		#(STEP*2);
	end
	endtask

	task  read_cmd;
	input  [15:0] addr;
//	output [15:0] data;
	begin
	   #STEP       lbus_we = 1; lbus_wd = 8'h00;       // Read command
      #STEP       lbus_we = 0; lbus_wd = 8'h00;
		#STEP   lbus_we = 1; lbus_wd = addr[15:8];  // Read address high
      #STEP       lbus_we = 0; lbus_wd = 8'h00;
		#STEP   lbus_we = 1; lbus_wd = addr[7:0];   // Read address low
      #STEP       lbus_we = 0; lbus_wd = 8'h00;
		#(STEP*2);
	end
	endtask

endmodule

