`timescale 1ns / 1ps

////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   02:35:09 04/04/2009
// Design Name:   CHIP_SASEBO_GII_LX50_AES_COMP
// Module Name:   C:/Users/ncc-1701-e/Documents/HDL Designs/aist09s/sasebo_sample_test/sasebo_gii_lx50_aes_comp/sasebo_gii_aes_tb01.v
// Project Name:  sasebo_gii_lx50_aes_comp
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: CHIP_SASEBO_GII_LX50_AES_COMP
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////
//
// Control
//   Bit0  Data ready
//   Bit1  Key ready
//   Bit2  Reset
//   Bit4  I ready
//   Bit5  C ready
//   Bit7  Length ready

module FPGA1_CMAC_TB1;

	// Inputs
	reg lbus_rstn;
	reg lbus_clk;

	reg [7:0] lbus_wd;
	reg lbus_we;
	reg lbus_re;


	// Outputs
	wire lbus_ful;
	wire lbus_aful;
	wire [7:0] lbus_rd;
	wire lbus_emp;
	wire lbus_aemp;
	wire lbus_rdy;
	wire trig_startn;
	wire trig_endn;
	wire trig_exec;
	wire [7:0] led;

	// Instantiate the Unit Under Test (UUT)
	FPGA1_CMAC uut (
		.lbus_wd(lbus_wd), 
		.lbus_we(lbus_we), 
		.lbus_ful(lbus_ful), 
		.lbus_aful(lbus_aful), 
		.lbus_rd(lbus_rd), 
		.lbus_re(lbus_re), 
		.lbus_emp(lbus_emp), 
		.lbus_aemp(lbus_aemp), 
		.lbus_rdy(lbus_rdy), 
		.lbus_clk(lbus_clk), 
		.lbus_rstn(lbus_rstn), 
		.trig_startn(trig_startn), 
		.trig_endn(trig_endn), 
		.trig_exec(trig_exec), 
		.led(led)
	);

   parameter PERIOD = 100;
   parameter real DUTY_CYCLE = 0.5;
   parameter OFFSET = 100;
   parameter STEP = 100;

	initial begin
	   forever
        begin
          lbus_clk = 1'b0;
          #(PERIOD-(PERIOD*DUTY_CYCLE)) lbus_clk = 1'b1;
          #(PERIOD*DUTY_CYCLE);
        end
	end

	initial begin
		// Initialize Inputs
		lbus_wd = 0;
		lbus_we = 0;
		lbus_re = 1;
//		lbus_clk = 0;
		lbus_rstn = 0;

		// Wait 100 ns for global reset to finish
		#(STEP*10)  lbus_rstn = 1;
        
		// Add stimulus here
      #(STEP*40);
		write_cmd(16'h0002, 16'h0004);    // Conrtol reset
//      #(STEP*20);
//		write_cmd(16'h000c, 16'h0001);    // Encode mode set


// =====================================================================
// 128biy-Key
// =====================================================================
      #(STEP*20);
		write_cmd(16'h000e, 16'h0000);    // 128-key mode set

      #(STEP*20);
		write_cmd(16'h0100, 16'h2b7e);    // Key set
      write_cmd(16'h0102, 16'h1516);
      write_cmd(16'h0104, 16'h28ae);
      write_cmd(16'h0106, 16'hd2a6);
      write_cmd(16'h0108, 16'habf7);
      write_cmd(16'h010a, 16'h1588);
      write_cmd(16'h010c, 16'h09cf);
      write_cmd(16'h010e, 16'h4f3c);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0002);    // Conrtol Key ready

    // ------------------------------------------------------
    // Example 1: Mlen 0
    // ------------------------------------------------------
      // Length set
      #(STEP*40);
      write_cmd(16'h0080, 16'h0000);    // Length High
      write_cmd(16'h0082, 16'h0000);    // Length Low
		write_cmd(16'h0002, 16'h0080);    // Conrtol Length ready

      // Data write
      #(STEP*10);
		write_cmd(16'h0140, 16'h0000);    // Dummy Data
      write_cmd(16'h0142, 16'h0000);
      write_cmd(16'h0144, 16'h0000);
      write_cmd(16'h0146, 16'h0000);
      write_cmd(16'h0148, 16'h0000);
      write_cmd(16'h014a, 16'h0000);
      write_cmd(16'h014c, 16'h0000);
      write_cmd(16'h014e, 16'h0000);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      // Data Read comnnd
      #(STEP*200);
      #(STEP*10); read_cmd(16'h0180);
      #(STEP*10); read_cmd(16'h0182);
      #(STEP*10); read_cmd(16'h0184);
      #(STEP*10); read_cmd(16'h0186);
      #(STEP*10); read_cmd(16'h0188);
      #(STEP*10); read_cmd(16'h018a);
      #(STEP*10); read_cmd(16'h018c);
      #(STEP*10); read_cmd(16'h018e);
      #(STEP*200);

    // ------------------------------------------------------
    // Example 2: Mlen 128
    // ------------------------------------------------------
      #(STEP*10);
      write_cmd(16'h0080, 16'h0000);    // Length High
      write_cmd(16'h0082, 16'h0010);    // Length Low
		write_cmd(16'h0002, 16'h0080);    // Conrtol Length ready Set

      #(STEP*10);
		write_cmd(16'h0140, 16'h6bc1);    // Data
      write_cmd(16'h0142, 16'hbee2);
      write_cmd(16'h0144, 16'h2e40);
      write_cmd(16'h0146, 16'h9f96);
      write_cmd(16'h0148, 16'he93d);
      write_cmd(16'h014a, 16'h7e11);
      write_cmd(16'h014c, 16'h7393);
      write_cmd(16'h014e, 16'h172a);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      // Read comnnd
      #(STEP*200);
      #(STEP*10); read_cmd(16'h0180);
      #(STEP*10); read_cmd(16'h0182);
      #(STEP*10); read_cmd(16'h0184);
      #(STEP*10); read_cmd(16'h0186);
      #(STEP*10); read_cmd(16'h0188);
      #(STEP*10); read_cmd(16'h018a);
      #(STEP*10); read_cmd(16'h018c);
      #(STEP*10); read_cmd(16'h018e);
      #(STEP*200);

    // ------------------------------------------------------
    // Example 3: Mlen 320
    // ------------------------------------------------------
      #(STEP*10);
      write_cmd(16'h0080, 16'h0000);    // Length High
      write_cmd(16'h0082, 16'h0028);    // Length Low
		write_cmd(16'h0002, 16'h0080);    // Conrtol Length ready

      #(STEP*10);
		write_cmd(16'h0140, 16'h6bc1);    // Data1
      write_cmd(16'h0142, 16'hbee2);
      write_cmd(16'h0144, 16'h2e40);
      write_cmd(16'h0146, 16'h9f96);
      write_cmd(16'h0148, 16'he93d);
      write_cmd(16'h014a, 16'h7e11);
      write_cmd(16'h014c, 16'h7393);
      write_cmd(16'h014e, 16'h172a);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*200);
		write_cmd(16'h0140, 16'hae2d);    // Data2
      write_cmd(16'h0142, 16'h8a57);
      write_cmd(16'h0144, 16'h1e03);
      write_cmd(16'h0146, 16'hac9c);
      write_cmd(16'h0148, 16'h9eb7);
      write_cmd(16'h014a, 16'h6fac);
      write_cmd(16'h014c, 16'h45af);
      write_cmd(16'h014e, 16'h8e51);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*200);
		write_cmd(16'h0140, 16'h30c8);    // Data3
      write_cmd(16'h0142, 16'h1c46);
      write_cmd(16'h0144, 16'ha35c);
      write_cmd(16'h0146, 16'he411);
      write_cmd(16'h0148, 16'h0000);
      write_cmd(16'h014a, 16'h0000);
      write_cmd(16'h014c, 16'h0000);
      write_cmd(16'h014e, 16'h0000);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      // Read comnnd
      #(STEP*200);
      #(STEP*10); read_cmd(16'h0180);
      #(STEP*10); read_cmd(16'h0182);
      #(STEP*10); read_cmd(16'h0184);
      #(STEP*10); read_cmd(16'h0186);
      #(STEP*10); read_cmd(16'h0188);
      #(STEP*10); read_cmd(16'h018a);
      #(STEP*10); read_cmd(16'h018c);
      #(STEP*10); read_cmd(16'h018e);
      #(STEP*200);

    // ------------------------------------------------------
    // Example 4: Mlen 512
    // ------------------------------------------------------
      #(STEP*10);
      write_cmd(16'h0080, 16'h0000);    // Length High
      write_cmd(16'h0082, 16'h0040);    // Length Low
		write_cmd(16'h0002, 16'h0080);    // Conrtol Length ready

      #(STEP*10);
		write_cmd(16'h0140, 16'h6bc1);    // Data1
      write_cmd(16'h0142, 16'hbee2);
      write_cmd(16'h0144, 16'h2e40);
      write_cmd(16'h0146, 16'h9f96);
      write_cmd(16'h0148, 16'he93d);
      write_cmd(16'h014a, 16'h7e11);
      write_cmd(16'h014c, 16'h7393);
      write_cmd(16'h014e, 16'h172a);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*200);
		write_cmd(16'h0140, 16'hae2d);    // Data2
      write_cmd(16'h0142, 16'h8a57);
      write_cmd(16'h0144, 16'h1e03);
      write_cmd(16'h0146, 16'hac9c);
      write_cmd(16'h0148, 16'h9eb7);
      write_cmd(16'h014a, 16'h6fac);
      write_cmd(16'h014c, 16'h45af);
      write_cmd(16'h014e, 16'h8e51);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*200);
		write_cmd(16'h0140, 16'h30c8);    // Data3
      write_cmd(16'h0142, 16'h1c46);
      write_cmd(16'h0144, 16'ha35c);
      write_cmd(16'h0146, 16'he411);
      write_cmd(16'h0148, 16'he5fb);
      write_cmd(16'h014a, 16'hc119);
      write_cmd(16'h014c, 16'h1a0a);
      write_cmd(16'h014e, 16'h52ef);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*200);
		write_cmd(16'h0140, 16'hf69f);    // Data4
      write_cmd(16'h0142, 16'h2445);
      write_cmd(16'h0144, 16'hdf4f);
      write_cmd(16'h0146, 16'h9b17);
      write_cmd(16'h0148, 16'had2b);
      write_cmd(16'h014a, 16'h417b);
      write_cmd(16'h014c, 16'he66c);
      write_cmd(16'h014e, 16'h3710);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      // Read comnnd
      #(STEP*200);
      #(STEP*10); read_cmd(16'h0180);
      #(STEP*10); read_cmd(16'h0182);
      #(STEP*10); read_cmd(16'h0184);
      #(STEP*10); read_cmd(16'h0186);
      #(STEP*10); read_cmd(16'h0188);
      #(STEP*10); read_cmd(16'h018a);
      #(STEP*10); read_cmd(16'h018c);
      #(STEP*10); read_cmd(16'h018e);
      #(STEP*200);


// =====================================================================
// 192bit key
// =====================================================================
      #(STEP*20);
		write_cmd(16'h000e, 16'h0001);    // 192-key mode set

      #(STEP*20);
		write_cmd(16'h0100, 16'h8e73);    // Key set0
      write_cmd(16'h0102, 16'hb0f7);
      write_cmd(16'h0104, 16'hda0e);
      write_cmd(16'h0106, 16'h6452);
      write_cmd(16'h0108, 16'hc810);
      write_cmd(16'h010a, 16'hf32b);
      write_cmd(16'h010c, 16'h8090);
      write_cmd(16'h010e, 16'h79e5);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0002);    // Conrtol Key ready

      #(STEP*20);
		write_cmd(16'h0100, 16'h62f8);    // Key set
      write_cmd(16'h0102, 16'head2);
      write_cmd(16'h0104, 16'h522c);
      write_cmd(16'h0106, 16'h6b7b);
      write_cmd(16'h0108, 16'h0000);
      write_cmd(16'h010a, 16'h0000);
      write_cmd(16'h010c, 16'h0000);
      write_cmd(16'h010e, 16'h0000);    // Key set

      #(STEP*10);
		write_cmd(16'h0002, 16'h0002);    // Conrtol Key ready

    // ------------------------------------------------------
    // Example 5: Mlen 0
    // ------------------------------------------------------
      // Length set
      #(STEP*50);
      write_cmd(16'h0080, 16'h0000);    // Length High
      write_cmd(16'h0082, 16'h0000);    // Length Low
		write_cmd(16'h0002, 16'h0080);    // Conrtol Length ready Input

      #(STEP*10);
		write_cmd(16'h0140, 16'h0000);    // Dummy Data set
      write_cmd(16'h0142, 16'h0000);
      write_cmd(16'h0144, 16'h0000);
      write_cmd(16'h0146, 16'h0000);
      write_cmd(16'h0148, 16'h0000);
      write_cmd(16'h014a, 16'h0000);
      write_cmd(16'h014c, 16'h0000);
      write_cmd(16'h014e, 16'h0000);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      // Read comnnd
      #(STEP*200);
      #(STEP*10); read_cmd(16'h0180);
      #(STEP*10); read_cmd(16'h0182);
      #(STEP*10); read_cmd(16'h0184);
      #(STEP*10); read_cmd(16'h0186);
      #(STEP*10); read_cmd(16'h0188);
      #(STEP*10); read_cmd(16'h018a);
      #(STEP*10); read_cmd(16'h018c);
      #(STEP*10); read_cmd(16'h018e);

    // ------------------------------------------------------
    // Example 6: Mlen 128
    // ------------------------------------------------------
      #(STEP*10);
      write_cmd(16'h0080, 16'h0000);    // Length High
      write_cmd(16'h0082, 16'h0010);    // Length Low
		write_cmd(16'h0002, 16'h0080);    // Conrtol Length ready Set

      #(STEP*10);
		write_cmd(16'h0140, 16'h6bc1);    // Data
      write_cmd(16'h0142, 16'hbee2);
      write_cmd(16'h0144, 16'h2e40);
      write_cmd(16'h0146, 16'h9f96);
      write_cmd(16'h0148, 16'he93d);
      write_cmd(16'h014a, 16'h7e11);
      write_cmd(16'h014c, 16'h7393);
      write_cmd(16'h014e, 16'h172a);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      // Read comnnd
      #(STEP*200);
      #(STEP*10); read_cmd(16'h0180);
      #(STEP*10); read_cmd(16'h0182);
      #(STEP*10); read_cmd(16'h0184);
      #(STEP*10); read_cmd(16'h0186);
      #(STEP*10); read_cmd(16'h0188);
      #(STEP*10); read_cmd(16'h018a);
      #(STEP*10); read_cmd(16'h018c);
      #(STEP*10); read_cmd(16'h018e);
      #(STEP*200);

    // ------------------------------------------------------
    // Example 7: Mlen 320
    // ------------------------------------------------------
      #(STEP*10);
      write_cmd(16'h0080, 16'h0000);    // Length High
      write_cmd(16'h0082, 16'h0028);    // Length Low
		write_cmd(16'h0002, 16'h0080);    // Conrtol Length ready

      #(STEP*10);
		write_cmd(16'h0140, 16'h6bc1);    // Data1
      write_cmd(16'h0142, 16'hbee2);
      write_cmd(16'h0144, 16'h2e40);
      write_cmd(16'h0146, 16'h9f96);
      write_cmd(16'h0148, 16'he93d);
      write_cmd(16'h014a, 16'h7e11);
      write_cmd(16'h014c, 16'h7393);
      write_cmd(16'h014e, 16'h172a);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*200);
		write_cmd(16'h0140, 16'hae2d);    // Data2
      write_cmd(16'h0142, 16'h8a57);
      write_cmd(16'h0144, 16'h1e03);
      write_cmd(16'h0146, 16'hac9c);
      write_cmd(16'h0148, 16'h9eb7);
      write_cmd(16'h014a, 16'h6fac);
      write_cmd(16'h014c, 16'h45af);
      write_cmd(16'h014e, 16'h8e51);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*200);
		write_cmd(16'h0140, 16'h30c8);    // Data3
      write_cmd(16'h0142, 16'h1c46);
      write_cmd(16'h0144, 16'ha35c);
      write_cmd(16'h0146, 16'he411);
      write_cmd(16'h0148, 16'h0000);
      write_cmd(16'h014a, 16'h0000);
      write_cmd(16'h014c, 16'h0000);
      write_cmd(16'h014e, 16'h0000);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      // Read comnnd
      #(STEP*200);
      #(STEP*10); read_cmd(16'h0180);
      #(STEP*10); read_cmd(16'h0182);
      #(STEP*10); read_cmd(16'h0184);
      #(STEP*10); read_cmd(16'h0186);
      #(STEP*10); read_cmd(16'h0188);
      #(STEP*10); read_cmd(16'h018a);
      #(STEP*10); read_cmd(16'h018c);
      #(STEP*10); read_cmd(16'h018e);
      #(STEP*200);

    // ------------------------------------------------------
    // Example 8: Mlen 512
    // ------------------------------------------------------
      #(STEP*10);
      write_cmd(16'h0080, 16'h0000);    // Length High
      write_cmd(16'h0082, 16'h0040);    // Length Low
		write_cmd(16'h0002, 16'h0080);    // Conrtol Length ready

      #(STEP*10);
		write_cmd(16'h0140, 16'h6bc1);    // Data1
      write_cmd(16'h0142, 16'hbee2);
      write_cmd(16'h0144, 16'h2e40);
      write_cmd(16'h0146, 16'h9f96);
      write_cmd(16'h0148, 16'he93d);
      write_cmd(16'h014a, 16'h7e11);
      write_cmd(16'h014c, 16'h7393);
      write_cmd(16'h014e, 16'h172a);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*200);
		write_cmd(16'h0140, 16'hae2d);    // Data2
      write_cmd(16'h0142, 16'h8a57);
      write_cmd(16'h0144, 16'h1e03);
      write_cmd(16'h0146, 16'hac9c);
      write_cmd(16'h0148, 16'h9eb7);
      write_cmd(16'h014a, 16'h6fac);
      write_cmd(16'h014c, 16'h45af);
      write_cmd(16'h014e, 16'h8e51);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*200);
		write_cmd(16'h0140, 16'h30c8);    // Data3
      write_cmd(16'h0142, 16'h1c46);
      write_cmd(16'h0144, 16'ha35c);
      write_cmd(16'h0146, 16'he411);
      write_cmd(16'h0148, 16'he5fb);
      write_cmd(16'h014a, 16'hc119);
      write_cmd(16'h014c, 16'h1a0a);
      write_cmd(16'h014e, 16'h52ef);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*200);
		write_cmd(16'h0140, 16'hf69f);    // Data4
      write_cmd(16'h0142, 16'h2445);
      write_cmd(16'h0144, 16'hdf4f);
      write_cmd(16'h0146, 16'h9b17);
      write_cmd(16'h0148, 16'had2b);
      write_cmd(16'h014a, 16'h417b);
      write_cmd(16'h014c, 16'he66c);
      write_cmd(16'h014e, 16'h3710);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      // Read comnnd
      #(STEP*200);
      read_cmd(16'h0180);
      read_cmd(16'h0182);
      read_cmd(16'h0184);
      read_cmd(16'h0186);
      read_cmd(16'h0188);
      read_cmd(16'h018a);
      read_cmd(16'h018c);
      read_cmd(16'h018e);
      #(STEP*200);



// =====================================================================
// 256bit key
// =====================================================================
      #(STEP*20);
		write_cmd(16'h000e, 16'h0002);    // 256-key mode set

      #(STEP*20);
		write_cmd(16'h0100, 16'h603d);    // Key set0
      write_cmd(16'h0102, 16'heb10);
      write_cmd(16'h0104, 16'h15ca);
      write_cmd(16'h0106, 16'h71be);
      write_cmd(16'h0108, 16'h2b73);
      write_cmd(16'h010a, 16'haef0);
      write_cmd(16'h010c, 16'h857d);
      write_cmd(16'h010e, 16'h7781);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0002);    // Conrtol Key ready

      #(STEP*20);
		write_cmd(16'h0100, 16'h1f35);    // Key set
      write_cmd(16'h0102, 16'h2c07);
      write_cmd(16'h0104, 16'h3b61);
      write_cmd(16'h0106, 16'h08d7);
      write_cmd(16'h0108, 16'h2d98);
      write_cmd(16'h010a, 16'h10a3);
      write_cmd(16'h010c, 16'h0914);
      write_cmd(16'h010e, 16'hdff4);    // Key set

      #(STEP*10);
		write_cmd(16'h0002, 16'h0002);    // Conrtol Key ready

    // ------------------------------------------------------
    // Example 9: Mlen 0
    // ------------------------------------------------------
      // Length set
      #(STEP*50);
      write_cmd(16'h0080, 16'h0000);    // Length High
      write_cmd(16'h0082, 16'h0000);    // Length Low
		write_cmd(16'h0002, 16'h0080);    // Conrtol Length ready Input

      #(STEP*10);
		write_cmd(16'h0140, 16'h0000);    // Dummy Data set
      write_cmd(16'h0142, 16'h0000);
      write_cmd(16'h0144, 16'h0000);
      write_cmd(16'h0146, 16'h0000);
      write_cmd(16'h0148, 16'h0000);
      write_cmd(16'h014a, 16'h0000);
      write_cmd(16'h014c, 16'h0000);
      write_cmd(16'h014e, 16'h0000);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      // Read comnnd
      #(STEP*200);
      #(STEP*10); read_cmd(16'h0180);
      #(STEP*10); read_cmd(16'h0182);
      #(STEP*10); read_cmd(16'h0184);
      #(STEP*10); read_cmd(16'h0186);
      #(STEP*10); read_cmd(16'h0188);
      #(STEP*10); read_cmd(16'h018a);
      #(STEP*10); read_cmd(16'h018c);
      #(STEP*10); read_cmd(16'h018e);

    // ------------------------------------------------------
    // Example 10: Mlen 128
    // ------------------------------------------------------
      #(STEP*10);
      write_cmd(16'h0080, 16'h0000);    // Length High
      write_cmd(16'h0082, 16'h0010);    // Length Low
		write_cmd(16'h0002, 16'h0080);    // Conrtol Length ready Set

      #(STEP*10);
		write_cmd(16'h0140, 16'h6bc1);    // Data
      write_cmd(16'h0142, 16'hbee2);
      write_cmd(16'h0144, 16'h2e40);
      write_cmd(16'h0146, 16'h9f96);
      write_cmd(16'h0148, 16'he93d);
      write_cmd(16'h014a, 16'h7e11);
      write_cmd(16'h014c, 16'h7393);
      write_cmd(16'h014e, 16'h172a);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      // Read comnnd
      #(STEP*200);
      #(STEP*10); read_cmd(16'h0180);
      #(STEP*10); read_cmd(16'h0182);
      #(STEP*10); read_cmd(16'h0184);
      #(STEP*10); read_cmd(16'h0186);
      #(STEP*10); read_cmd(16'h0188);
      #(STEP*10); read_cmd(16'h018a);
      #(STEP*10); read_cmd(16'h018c);
      #(STEP*10); read_cmd(16'h018e);
      #(STEP*200);

    // ------------------------------------------------------
    // Example 11: Mlen 320
    // ------------------------------------------------------
      #(STEP*10);
      write_cmd(16'h0080, 16'h0000);    // Length High
      write_cmd(16'h0082, 16'h0028);    // Length Low
		write_cmd(16'h0002, 16'h0080);    // Conrtol Length ready

      #(STEP*10);
		write_cmd(16'h0140, 16'h6bc1);    // Data1
      write_cmd(16'h0142, 16'hbee2);
      write_cmd(16'h0144, 16'h2e40);
      write_cmd(16'h0146, 16'h9f96);
      write_cmd(16'h0148, 16'he93d);
      write_cmd(16'h014a, 16'h7e11);
      write_cmd(16'h014c, 16'h7393);
      write_cmd(16'h014e, 16'h172a);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*200);
		write_cmd(16'h0140, 16'hae2d);    // Data2
      write_cmd(16'h0142, 16'h8a57);
      write_cmd(16'h0144, 16'h1e03);
      write_cmd(16'h0146, 16'hac9c);
      write_cmd(16'h0148, 16'h9eb7);
      write_cmd(16'h014a, 16'h6fac);
      write_cmd(16'h014c, 16'h45af);
      write_cmd(16'h014e, 16'h8e51);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*200);
		write_cmd(16'h0140, 16'h30c8);    // Data3
      write_cmd(16'h0142, 16'h1c46);
      write_cmd(16'h0144, 16'ha35c);
      write_cmd(16'h0146, 16'he411);
      write_cmd(16'h0148, 16'h0000);
      write_cmd(16'h014a, 16'h0000);
      write_cmd(16'h014c, 16'h0000);
      write_cmd(16'h014e, 16'h0000);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      // Read comnnd
      #(STEP*200);
      #(STEP*10); read_cmd(16'h0180);
      #(STEP*10); read_cmd(16'h0182);
      #(STEP*10); read_cmd(16'h0184);
      #(STEP*10); read_cmd(16'h0186);
      #(STEP*10); read_cmd(16'h0188);
      #(STEP*10); read_cmd(16'h018a);
      #(STEP*10); read_cmd(16'h018c);
      #(STEP*10); read_cmd(16'h018e);
      #(STEP*200);

    // ------------------------------------------------------
    // Example 12: Mlen 512
    // ------------------------------------------------------
      #(STEP*10);
      write_cmd(16'h0080, 16'h0000);    // Length High
      write_cmd(16'h0082, 16'h0040);    // Length Low
		write_cmd(16'h0002, 16'h0080);    // Conrtol Length ready

      #(STEP*10);
		write_cmd(16'h0140, 16'h6bc1);    // Data1
      write_cmd(16'h0142, 16'hbee2);
      write_cmd(16'h0144, 16'h2e40);
      write_cmd(16'h0146, 16'h9f96);
      write_cmd(16'h0148, 16'he93d);
      write_cmd(16'h014a, 16'h7e11);
      write_cmd(16'h014c, 16'h7393);
      write_cmd(16'h014e, 16'h172a);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*200);
		write_cmd(16'h0140, 16'hae2d);    // Data2
      write_cmd(16'h0142, 16'h8a57);
      write_cmd(16'h0144, 16'h1e03);
      write_cmd(16'h0146, 16'hac9c);
      write_cmd(16'h0148, 16'h9eb7);
      write_cmd(16'h014a, 16'h6fac);
      write_cmd(16'h014c, 16'h45af);
      write_cmd(16'h014e, 16'h8e51);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*200);
		write_cmd(16'h0140, 16'h30c8);    // Data3
      write_cmd(16'h0142, 16'h1c46);
      write_cmd(16'h0144, 16'ha35c);
      write_cmd(16'h0146, 16'he411);
      write_cmd(16'h0148, 16'he5fb);
      write_cmd(16'h014a, 16'hc119);
      write_cmd(16'h014c, 16'h1a0a);
      write_cmd(16'h014e, 16'h52ef);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*200);
		write_cmd(16'h0140, 16'hf69f);    // Data4
      write_cmd(16'h0142, 16'h2445);
      write_cmd(16'h0144, 16'hdf4f);
      write_cmd(16'h0146, 16'h9b17);
      write_cmd(16'h0148, 16'had2b);
      write_cmd(16'h014a, 16'h417b);
      write_cmd(16'h014c, 16'he66c);
      write_cmd(16'h014e, 16'h3710);

      #(STEP*10);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      // Read comnnd
      #(STEP*200);
      read_cmd(16'h0180);
      read_cmd(16'h0182);
      read_cmd(16'h0184);
      read_cmd(16'h0186);
      read_cmd(16'h0188);
      read_cmd(16'h018a);
      read_cmd(16'h018c);
      read_cmd(16'h018e);


      #(STEP*400);
      $stop;
	end


   // Write command
	task  write_cmd;
	input [15:0] addr;
	input [15:0] data;
	begin
	   #STEP       lbus_we = 1; lbus_wd = 8'h01;       // Write command
      #STEP       lbus_we = 0; lbus_wd = 8'h00;
		#(STEP*2)   lbus_we = 1; lbus_wd = addr[15:8];  // Write address high
      #STEP       lbus_we = 0; lbus_wd = 8'h00;
		#(STEP*2)   lbus_we = 1; lbus_wd = addr[7:0];   // Write address low
      #STEP       lbus_we = 0; lbus_wd = 8'h00;
		#(STEP*2)   lbus_we = 1; lbus_wd = data[15:8];  // Write data high
      #STEP       lbus_we = 0; lbus_wd = 8'h00;
		#(STEP*2)   lbus_we = 1; lbus_wd = data[7:0];   // Write data low
      #STEP       lbus_we = 0; lbus_wd = 8'h00;
		#(STEP*2);
	end
	endtask

	task  read_cmd;
	input  [15:0] addr;
//	output [15:0] data;
	begin
	   #STEP       lbus_we = 1; lbus_wd = 8'h00;       // Read command
      #STEP       lbus_we = 0; lbus_wd = 8'h00;
		#STEP   lbus_we = 1; lbus_wd = addr[15:8];  // Read address high
      #STEP       lbus_we = 0; lbus_wd = 8'h00;
		#STEP   lbus_we = 1; lbus_wd = addr[7:0];   // Read address low
      #STEP       lbus_we = 0; lbus_wd = 8'h00;
		#(STEP*2);
	end
	endtask

endmodule

