`timescale 1ns / 1ps

////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   02:35:09 04/04/2009
// Design Name:   CHIP_SASEBO_GII_LX50_AES_COMP
// Module Name:   C:/Users/ncc-1701-e/Documents/HDL Designs/aist09s/sasebo_sample_test/sasebo_gii_lx50_aes_comp/sasebo_gii_aes_tb01.v
// Project Name:  sasebo_gii_lx50_aes_comp
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: CHIP_SASEBO_GII_LX50_AES_COMP
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////
//
// Control
//   Bit0  Data ready
//   Bit1  Key ready
//   Bit2  Reset
//   Bit4  I ready
//   Bit5  C ready
//   Bit7  Length ready

module FPGA1_SHA_TB1;

	// Inputs
	reg lbus_rstn;
	reg lbus_clk;

	reg [7:0] lbus_wd;
	reg lbus_we;
	reg lbus_re;


	// Outputs
	wire lbus_ful;
	wire lbus_aful;
	wire [7:0] lbus_rd;
	wire lbus_emp;
	wire lbus_aemp;
	wire lbus_rdy;
	wire trig_startn;
	wire trig_endn;
	wire trig_exec;
	wire [7:0] led;

  reg  [31:0] W[0:15];


	// Instantiate the Unit Under Test (UUT)
	FPGA1_SHA256 uut (
		.lbus_wd(lbus_wd), 
		.lbus_we(lbus_we), 
		.lbus_ful(lbus_ful), 
		.lbus_aful(lbus_aful), 
		.lbus_rd(lbus_rd), 
		.lbus_re(lbus_re), 
		.lbus_emp(lbus_emp), 
		.lbus_aemp(lbus_aemp), 
		.lbus_rdy(lbus_rdy), 
		.lbus_clk(lbus_clk), 
		.lbus_rstn(lbus_rstn), 
		.trig_startn(trig_startn), 
		.trig_endn(trig_endn), 
		.trig_exec(trig_exec), 
		.led(led)
	);

   parameter PERIOD = 100;
   parameter real DUTY_CYCLE = 0.5;
   parameter OFFSET = 100;
   parameter STEP = 100;

  initial W[ 0] = 32'h61626380;
  initial W[ 1] = 32'h00000000;
  initial W[ 2] = 32'h00000000;
  initial W[ 3] = 32'h00000000;
  initial W[ 4] = 32'h00000000;
  initial W[ 5] = 32'h00000000;
  initial W[ 6] = 32'h00000000;
  initial W[ 7] = 32'h00000000;
  initial W[ 8] = 32'h00000000;
  initial W[ 9] = 32'h00000000;
  initial W[10] = 32'h00000000;
  initial W[11] = 32'h00000000;
  initial W[12] = 32'h00000000;
  initial W[13] = 32'h00000000;
  initial W[14] = 32'h00000000;
  initial W[15] = 32'h00000018;

	initial begin
	   forever
        begin
          lbus_clk = 1'b0;
          #(PERIOD-(PERIOD*DUTY_CYCLE)) lbus_clk = 1'b1;
          #(PERIOD*DUTY_CYCLE);
        end
	end

	initial begin
		// Initialize Inputs
		lbus_wd = 0;
		lbus_we = 0;
		lbus_re = 1;
		lbus_rstn = 0;

		// Wait 100 ns for global reset to finish
		#(STEP*10)  lbus_rstn = 1;
        
		// Add stimulus here
      #(STEP*40);
		write_cmd(16'h0002, 16'h0004);    // Conrtol reset

// =====================================================================
// 
// =====================================================================
      #(STEP*20);
      #(STEP*10);
//		write_cmd(16'h0002, 16'h0002);    // Conrtol Key ready

    // ------------------------------------------------------
    // Example 1: Mlen 0
    // ------------------------------------------------------
      // Data write
      #(STEP*10);
		write_cmd(16'h0100, W[0][31:16]);    //
      write_cmd(16'h0102, W[0][15:0]);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*10);
		write_cmd(16'h0100, W[1][31:16]);    //
      write_cmd(16'h0102, W[1][15:0]);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*10);
		write_cmd(16'h0100, W[2][31:16]);    //
      write_cmd(16'h0102, W[2][15:0]);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*10);
		write_cmd(16'h0100, W[3][31:16]);    //
      write_cmd(16'h0102, W[3][15:0]);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*10);
		write_cmd(16'h0100, W[4][31:16]);    //
      write_cmd(16'h0102, W[4][15:0]);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*10);
		write_cmd(16'h0100, W[5][31:16]);    //
      write_cmd(16'h0102, W[5][15:0]);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*10);
		write_cmd(16'h0100, W[6][31:16]);    //
      write_cmd(16'h0102, W[6][15:0]);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*10);
		write_cmd(16'h0100, W[7][31:16]);    //
      write_cmd(16'h0102, W[7][15:0]);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*10);
		write_cmd(16'h0100, W[8][31:16]);    //
      write_cmd(16'h0102, W[8][15:0]);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*10);
		write_cmd(16'h0100, W[9][31:16]);    //
      write_cmd(16'h0102, W[9][15:0]);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*10);
		write_cmd(16'h0100, W[10][31:16]);    //
      write_cmd(16'h0102, W[10][15:0]);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*10);
		write_cmd(16'h0100, W[11][31:16]);    //
      write_cmd(16'h0102, W[11][15:0]);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*10);
		write_cmd(16'h0100, W[12][31:16]);    //
      write_cmd(16'h0102, W[12][15:0]);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*10);
		write_cmd(16'h0100, W[13][31:16]);    //
      write_cmd(16'h0102, W[13][15:0]);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*10);
		write_cmd(16'h0100, W[14][31:16]);    //
      write_cmd(16'h0102, W[14][15:0]);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*10);
		write_cmd(16'h0100, W[15][31:16]);    //
      write_cmd(16'h0102, W[15][15:0]);
		write_cmd(16'h0002, 16'h0001);    // Conrtol Data ready

      #(STEP*200);


      // Data Read comnnd
      #(STEP*500);
      #(STEP*10); read_cmd(16'h0180);
      #(STEP*10); read_cmd(16'h0182);
      #(STEP*10); read_cmd(16'h0184);
      #(STEP*10); read_cmd(16'h0186);
      #(STEP*10); read_cmd(16'h0188);
      #(STEP*10); read_cmd(16'h018a);
      #(STEP*10); read_cmd(16'h018c);
      #(STEP*10); read_cmd(16'h018e);
      #(STEP*10); read_cmd(16'h0190);
      #(STEP*10); read_cmd(16'h0192);
      #(STEP*10); read_cmd(16'h0194);
      #(STEP*10); read_cmd(16'h0196);
      #(STEP*10); read_cmd(16'h0198);
      #(STEP*10); read_cmd(16'h019a);
      #(STEP*10); read_cmd(16'h019c);
      #(STEP*10); read_cmd(16'h019e);
      #(STEP*200);

  $stop;

  $stop;
end


   // Write command
	task  write_cmd;
	input [15:0] addr;
	input [15:0] data;
	begin
	   #STEP       lbus_we = 1; lbus_wd = 8'h01;       // Write command
      #STEP       lbus_we = 0; lbus_wd = 8'h00;
		#(STEP*2)   lbus_we = 1; lbus_wd = addr[15:8];  // Write address high
      #STEP       lbus_we = 0; lbus_wd = 8'h00;
		#(STEP*2)   lbus_we = 1; lbus_wd = addr[7:0];   // Write address low
      #STEP       lbus_we = 0; lbus_wd = 8'h00;
		#(STEP*2)   lbus_we = 1; lbus_wd = data[15:8];  // Write data high
      #STEP       lbus_we = 0; lbus_wd = 8'h00;
		#(STEP*2)   lbus_we = 1; lbus_wd = data[7:0];   // Write data low
      #STEP       lbus_we = 0; lbus_wd = 8'h00;
		#(STEP*2);
	end
	endtask

	task  read_cmd;
	input  [15:0] addr;
//	output [15:0] data;
	begin
	   #STEP       lbus_we = 1; lbus_wd = 8'h00;       // Read command
      #STEP       lbus_we = 0; lbus_wd = 8'h00;
		#STEP   lbus_we = 1; lbus_wd = addr[15:8];  // Read address high
      #STEP       lbus_we = 0; lbus_wd = 8'h00;
		#STEP   lbus_we = 1; lbus_wd = addr[7:0];   // Read address low
      #STEP       lbus_we = 0; lbus_wd = 8'h00;
		#(STEP*2);
	end
	endtask

endmodule

